<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>HexPlot: /home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/exec/example_handler.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.1 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>File&nbsp;Members</span></a></li>
    </ul>
  </div>
<h1>/home/ericabro/HexPlot/20200528/HGCAL_sensor_analysis/src/exec/example_handler.h</h1><a href="example__handler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00007"></a>00007 <span class="preprocessor">#ifndef EXAMPLE_HANDLER_H</span>
<a name="l00008"></a>00008 <span class="preprocessor"></span><span class="preprocessor">#define EXAMPLE_HANDLER_H</span>
<a name="l00009"></a>00009 <span class="preprocessor"></span>
<a name="l00010"></a>00010 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00011"></a>00011 
<a name="l00012"></a>00012 <span class="preprocessor">#include &quot;../utils/cpp_utils.h&quot;</span>
<a name="l00013"></a>00013 
<a name="l00015"></a><a class="code" href="classexample__handler.html">00015</a> <span class="keyword">class </span><a class="code" href="classexample__handler.html" title="A class for handling example commands.">example_handler</a> {
<a name="l00016"></a>00016  <span class="keyword">public</span>:
<a name="l00018"></a>00018   <span class="keywordtype">void</span> <a class="code" href="classexample__handler.html#a3a24986b89f2623ed7f58c5de3f9b35f" title="Print the list of examples.">print_examples</a>();
<a name="l00020"></a><a class="code" href="classexample__handler.html#a900c099313e137c227c9b739139f06ea">00020</a>   std::string <a class="code" href="classexample__handler.html#a900c099313e137c227c9b739139f06ea" title="Return the ith example command.">get_example_description</a>(<span class="keywordtype">int</span> i) { <span class="keywordflow">return</span> descriptions.at(i); };
<a name="l00021"></a>00021   std::string get_example(<span class="keywordtype">int</span> i) { <span class="keywordflow">return</span> mainCommand + commands.at(i); };
<a name="l00023"></a><a class="code" href="classexample__handler.html#a136f9a6f0badab7ca97ed718861ae198">00023</a>   std::string <a class="code" href="classexample__handler.html#a136f9a6f0badab7ca97ed718861ae198" title="Return the ith example command without main command.">get_example_no_main_cmd</a>(<span class="keywordtype">int</span> i) { <span class="keywordflow">return</span> commands.at(i); };
<a name="l00025"></a><a class="code" href="classexample__handler.html#a1b1dda370b7c55525061e9aca7fb5153">00025</a>   <span class="keywordtype">int</span> <a class="code" href="classexample__handler.html#a1b1dda370b7c55525061e9aca7fb5153" title="Return number of examples.">get_n_examples</a>() { <span class="keywordflow">return</span> nExamples; };
<a name="l00027"></a>00027   <span class="keyword">explicit</span> <a class="code" href="classexample__handler.html#a1691843df8463d847e21ee81a69abe7e" title="Constructor.">example_handler</a>(<span class="keyword">const</span> std::string&amp; mainCMD);
<a name="l00028"></a>00028 
<a name="l00029"></a>00029  <span class="keyword">private</span>:
<a name="l00030"></a>00030   <span class="keywordtype">int</span> nExamples;
<a name="l00031"></a>00031   std::string mainCommand;
<a name="l00032"></a>00032   std::string sourceDir;
<a name="l00033"></a>00033   std::vector&lt;std::string&gt; commands;
<a name="l00034"></a>00034   std::vector&lt;std::string&gt; descriptions;
<a name="l00036"></a><a class="code" href="classexample__handler.html#aa25b4b87983eb6d30ba01be84ad784b2">00036</a>   <span class="keywordtype">void</span> <a class="code" href="classexample__handler.html#aa25b4b87983eb6d30ba01be84ad784b2" title="Adds an example.">add_example</a>(<span class="keyword">const</span> std::string&amp; descr, std::string options) {
<a name="l00037"></a>00037     ++nExamples;
<a name="l00038"></a>00038     descriptions.push_back(descr);
<a name="l00039"></a>00039     options = replace_string_all(options, <span class="stringliteral">&quot;../&quot;</span>, sourceDir);
<a name="l00040"></a>00040     commands.push_back(options);
<a name="l00041"></a>00041   };
<a name="l00043"></a><a class="code" href="classexample__handler.html#ab7119b63642560bd4aff35fe04ad0f52">00043</a>   <span class="keywordtype">void</span> <a class="code" href="classexample__handler.html#ab7119b63642560bd4aff35fe04ad0f52" title="Adds an example, using the description of the previous example.">add_example</a>(std::string options) { <a class="code" href="classexample__handler.html#ab7119b63642560bd4aff35fe04ad0f52" title="Adds an example, using the description of the previous example.">add_example</a>(descriptions.back(), std::move(options)); };
<a name="l00044"></a>00044 };
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
</pre></div></div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr size="1"/><address style="text-align: right;"><small>Generated on 29 May 2020 for HexPlot by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.6.1 </small></address>
</body>
</html>
